<?php
if ( !defined('ABSPATH')) exit; // Exit if accessed directly
/*
Weaver Xtreme Plus Shortcoder

This code is Copyright 2011 by Bruce Wampler, all rights reserved.
This code is licensed under the terms of the accompanying license file: license.html.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

/* =========================== SmartMenus ========================== */
function weaverxplus_has_smartmenus() { return true; }

function weaverxplus_save_smartmenus() {
	/* Save options from save smartmenus */


	foreach (array('primary','secondary','extra') as $menu) {
		$opt = "sm-{$menu}";
		if (isset($_POST[$opt . '-js-opt'])) {
			weaverxplus_setopt($opt . '-js-opt', weaverx_filter_textarea(stripslashes($_POST[$opt . '-js-opt'])));
		}

		if (isset($_POST["{$opt}-uparrow"])) {
			weaverxplus_setopt("{$opt}-uparrow", true);
			$js = weaverxplus_getopt($opt . '-js-opt');
			if (!$js) {
				weaverxplus_setopt($opt . '-js-opt',
"{subIndicatorsText:'',subMenusMinWidth:'1em',subMenusMaxWidth:'25em',
mainMenuSubOffsetX:-6,mainMenuSubOffsetY:4,subMenusSubOffsetX:6,subMenusSubOffsetY:-6}");
			}
		} else {
			weaverxplus_setopt("{$opt}-uparrow", false);
		}

		if ( isset($_POST["{$opt}-uparrow-border"]) && weaverxplus_getopt("{$opt}-uparrow")) {
			weaverxplus_setopt("{$opt}-uparrow-border", true);
		} else {
			weaverxplus_setopt("{$opt}-uparrow-border", false);
		}

		if ( isset($_POST["{$opt}-uparrow-x"])) {
			weaverxplus_setopt("{$opt}-uparrow-x", $_POST["{$opt}-uparrow-x"]);
		} else {
			weaverxplus_setopt("{$opt}-uparrow-x", '');
		}

		if ( isset($_POST["{$opt}-downbelow"])) {
			weaverxplus_setopt("{$opt}-downbelow", true);
		} else {
			weaverxplus_setopt("{$opt}-downbelow", false);
		}

		if ( isset($_POST["{$opt}-hamburger"])) {
			weaverx_setopt("m_{$menu}_hamburger", $_POST["{$opt}-hamburger"]);
		} else {
			weaverx_setopt("m_{$menu}_hamburger", '');
		}

	}

	weaverxplus_update_opts();
	weaverx_save_opts('xplus',true);
	/* and let the user know something happened */
	echo '<div id="message" class="updated fade"><p><strong>Weaver Xtreme Plus SmartMenu Options Saved</strong></p></div>';
}
?>
